
ArrayList tableau = new ArrayList();
Ell ell;
float r;
float g;
float b;
int alpha;

import ddf.minim.analysis.*;
import ddf.minim.*;

Minim minim;  
AudioPlayer player;
FFT fftLin;
FFT fft;
BeatDetect beat;
BeatListener bl;
float tempo= 1;
float kickSize, snareSize, hatSize;
AudioInput in;
float amplitude;
int highest = 0;
int h = 0;
int amp = 0;
int fact = 1000;
boolean tempsFort;

float angC;
float angZ;
float ro;
float orbitRad = 200;

int delai = 10000;
int start;

boolean came = false;


ArrayList ampli = new ArrayList();

void setup() {

  size(1024, 768, OPENGL);
  background(0);
  minim = new Minim(this);
  player = minim.loadFile("danubeC.mp3", 2048);
  in = minim.getLineIn(Minim.STEREO, 2048, 44100);
  player.play();
  // create an FFT object that has a time-domain buffer the same size as jingle's sample buffer
  // note that this needs to be a power of two 
  // and that it means the size of the spectrum will be 1024. 
  // see the online tutorial for more info.
  fftLin = new FFT(player.bufferSize(), player.sampleRate());
  // calculate the averages by grouping frequency bands linearly. use 30 averages.
  fftLin.linAverages(30); 
  fft = new FFT(in.mix.size(), 44100);
  beat = new BeatDetect(in.bufferSize(), in.sampleRate());
  beat.setSensitivity(300);  
  kickSize = snareSize = 60;
  hatSize= 50;
  
  start = millis();

  float posx=0, posy=0, posz=0, larg=0, haut=0, ang=0;

  for (int i = 0; i<20; i++) {

    r = random(190, 255);
    g= random(210, 255);
    b= random(200, 255);
    // haut = random(1, 2);
    haut = random(480, 530);
    larg = random(170, 400);
    //larg = random(1,2);
    alpha = int(random(10, 15));
    ang = random(-0.000001, 0.0000001);
    color coul = color(r, g, b, alpha);
    posx = random(10, 45);
    posy = random(-50, 50);
    ell = new Ell(posx, posy, posz, larg, haut, coul, ang);
    tableau.add(ell);
  }

  for (int i = 0; i<20; i++) {

    r = random(0, 25);
    g= random(0, 20);
    b= random(240, 255);
    // haut = random(1, 2);
    haut = random(570, 600);
    larg = random(270, 370);
    //larg = random(1,2);
    alpha = int(random(15, 20));
    ang = random(-0.000005, 0.0000005);
    color coul = color(r, g, b, alpha);
    posx = random(-10, 55);
    posy = random(-50, 50);
    ell = new Ell(posx, posy, posz, larg, haut, coul, ang);
    tableau.add(ell);
  } 
  start = millis();
  timer();
}

void draw() {
  // background(0);
 // println(h);
 
 timer();
 println(came);
  ro = (TWO_PI*millis()/20000);
 float val1 = cos(ro)*orbitRad;
  float val2 = sin(ro)*orbitRad;
 float valz =  ((0+val2+random(-10.0, 10.0))*h)+random(100,500);
 if (valz>0){
//   int hz = int(random(10));
//   if( hz == 10){
   valz = -valz;
   //}
 }
 
 if(came){
   //println("cameraon");
   
  camera(width/2.0-val1, height/2.0, -1000+(h*tempo*2), width/2.0, height/2.0, 0, 0, 1, 0);
 };
 

  lights();
  beat.detect(player.mix);
    if ( beat.isOnset() ){
      tempo = 7;
      tempsFort = true;
    }else{
      tempo = 0.2;
      tempsFort = false;
    }
   
  int zar = int(random(1, 4));
 if (frameCount%zar==0) {
    pushMatrix();
    translate(width/2, height/2, 100);
   
    fill(5, 12);
    noStroke();
    box(2000, 2000, 2000);

    popMatrix();
 }
 

  fft.forward(in.left);//travailler en live

  for (int i = 0; i < width; i++) {
    float amplitude = 0;
    for (int j = 0; j <fftLin.avgSize(); j++) { 
      amplitude += fft.getFreq(i * 8 + j);

      amp = (int) amplitude;

      if (amplitude>highest) {
        highest= (int)amplitude;
      }
      if (amplitude >0) {

        float h1 = map(amp, 0, highest, 0, height-10);
        h = (int)h1*fact;
      }
    }
  }

int a = int(angC);
//println(a);
float nbreE = map(a, 0, 40, 0, 38);
int nbre= int(nbreE);
constrain(nbre, 1, 38);
if (tempsFort ){
 nbre = tableau.size();
}
  for ( int i = 0; i<1+abs(nbre); i++) {
    Ell ell = (Ell) tableau.get(i);
    ell.affiche();
  }
};


void timer(){
  if(millis() > (start+delai)){
    //println("statplusdelai=======" + (start+delai));
   // println(millis());
    start = millis();
    delai = int (random(5000,10000));
    if(!came){
    came = true;
    }else{
      came= false;
    
    //println("c'estlecastrue");
  }
}
}

  


void stop()
{
  // always close Minim audio classes when you are done with them
  player.close();
  // always stop Minim before exiting
  minim.stop();

  super.stop();
}

