import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.analysis.*; 
import ddf.minim.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class valse extends PApplet {


ArrayList tableau = new ArrayList();
Ell ell;
float r;
float g;
float b;
int alpha;




Minim minim;  
AudioPlayer player;
FFT fftLin;
FFT fft;
BeatDetect beat;
BeatListener bl;
float tempo= 1;
float kickSize, snareSize, hatSize;
AudioInput in;
float amplitude;
int highest = 0;
int h = 0;
int amp = 0;
int fact = 1000;
boolean tempsFort;

float angC;
float angZ;
float ro;
float orbitRad = 200;

int delai = 10000;
int start;

boolean came = false;


ArrayList ampli = new ArrayList();

public void setup() {

  size(1024, 768, OPENGL);
  background(0);
  minim = new Minim(this);
  player = minim.loadFile("danubeC.mp3", 2048);
  in = minim.getLineIn(Minim.STEREO, 2048, 44100);
  player.play();
  // create an FFT object that has a time-domain buffer the same size as jingle's sample buffer
  // note that this needs to be a power of two 
  // and that it means the size of the spectrum will be 1024. 
  // see the online tutorial for more info.
  fftLin = new FFT(player.bufferSize(), player.sampleRate());
  // calculate the averages by grouping frequency bands linearly. use 30 averages.
  fftLin.linAverages(30); 
  fft = new FFT(in.mix.size(), 44100);
  beat = new BeatDetect(in.bufferSize(), in.sampleRate());
  beat.setSensitivity(300);  
  kickSize = snareSize = 60;
  hatSize= 50;
  
  start = millis();

  float posx=0, posy=0, posz=0, larg=0, haut=0, ang=0;

  for (int i = 0; i<20; i++) {

    r = random(190, 255);
    g= random(210, 255);
    b= random(200, 255);
    // haut = random(1, 2);
    haut = random(480, 530);
    larg = random(170, 400);
    //larg = random(1,2);
    alpha = PApplet.parseInt(random(10, 15));
    ang = random(-0.000001f, 0.0000001f);
    int coul = color(r, g, b, alpha);
    posx = random(10, 45);
    posy = random(-50, 50);
    ell = new Ell(posx, posy, posz, larg, haut, coul, ang);
    tableau.add(ell);
  }

  for (int i = 0; i<20; i++) {

    r = random(0, 25);
    g= random(0, 20);
    b= random(240, 255);
    // haut = random(1, 2);
    haut = random(570, 600);
    larg = random(270, 370);
    //larg = random(1,2);
    alpha = PApplet.parseInt(random(15, 20));
    ang = random(-0.000005f, 0.0000005f);
    int coul = color(r, g, b, alpha);
    posx = random(-10, 55);
    posy = random(-50, 50);
    ell = new Ell(posx, posy, posz, larg, haut, coul, ang);
    tableau.add(ell);
  } 
  start = millis();
  timer();
}

public void draw() {
  // background(0);
 // println(h);
 
 timer();
 println(came);
  ro = (TWO_PI*millis()/20000);
 float val1 = cos(ro)*orbitRad;
  float val2 = sin(ro)*orbitRad;
 float valz =  ((0+val2+random(-10.0f, 10.0f))*h)+random(100,500);
 if (valz>0){
//   int hz = int(random(10));
//   if( hz == 10){
   valz = -valz;
   //}
 }
 
 if(came){
   //println("cameraon");
   
  camera(width/2.0f-val1, height/2.0f, -1000+(h*tempo*2), width/2.0f, height/2.0f, 0, 0, 1, 0);
 };
 

  lights();
  beat.detect(player.mix);
    if ( beat.isOnset() ){
      tempo = 7;
      tempsFort = true;
    }else{
      tempo = 0.2f;
      tempsFort = false;
    }
   
  int zar = PApplet.parseInt(random(1, 4));
 if (frameCount%zar==0) {
    pushMatrix();
    translate(width/2, height/2, 100);
   
    fill(5, 12);
    noStroke();
    box(2000, 2000, 2000);

    popMatrix();
 }
 

  fft.forward(in.left);//travailler en live

  for (int i = 0; i < width; i++) {
    float amplitude = 0;
    for (int j = 0; j <fftLin.avgSize(); j++) { 
      amplitude += fft.getFreq(i * 8 + j);

      amp = (int) amplitude;

      if (amplitude>highest) {
        highest= (int)amplitude;
      }
      if (amplitude >0) {

        float h1 = map(amp, 0, highest, 0, height-10);
        h = (int)h1*fact;
      }
    }
  }

int a = PApplet.parseInt(angC);
//println(a);
float nbreE = map(a, 0, 40, 0, 38);
int nbre= PApplet.parseInt(nbreE);
constrain(nbre, 1, 38);
if (tempsFort ){
 nbre = tableau.size();
}
  for ( int i = 0; i<1+abs(nbre); i++) {
    Ell ell = (Ell) tableau.get(i);
    ell.affiche();
  }
};


public void timer(){
  if(millis() > (start+delai)){
    //println("statplusdelai=======" + (start+delai));
   // println(millis());
    start = millis();
    delai = PApplet.parseInt (random(5000,10000));
    if(!came){
    came = true;
    }else{
      came= false;
    
    //println("c'estlecastrue");
  }
}
}

  


public void stop()
{
  // always close Minim audio classes when you are done with them
  player.close();
  // always stop Minim before exiting
  minim.stop();

  super.stop();
}

class Ell {
  
  float px, py, pz, w, h;
  int c;
  float inc;
  float v = 0.0000000000000000001f;
 //float orbitRad = 200;
  
  Ell(float _px, float _py, float _pz, float _w, float _h, int _c, float _inc){
   px =  _px;
   py= _py;
   pz = _pz;
   w= _w;
   h = _h;
   c = _c;
   inc = _inc;
  }
  
  public void affiche(){
    
    ellipseMode(CENTER);
   
   if(beat.isHat()){
    strokeWeight((2+hatSize)*tempo);
   // println("hat!!!======" + (2+hatSize)*tempo);
    //println(hatSize);
    float  nr = random(0, 55);
   float ng= random(0, 20);
    float nb= random(240, 255);
    noStroke();
    fill(nr,ng,nb,7);
   }else{
     strokeWeight( 2);
     noFill();
   }
   stroke(c);
   
   
    ro = (TWO_PI*millis()/(20000));
  
 float x = (cos(ro)*orbitRad);
 angC = (cos(ro)*orbitRad)*tempo;

  float z = (sin(ro)*orbitRad);
 angZ = (sin(ro)*orbitRad)*tempo;
 //println(angZ);
  //println("h===============" +( z*2-(h/fact)));
    pushMatrix();
    translate(width/2+x,height/2+(x/2),0 + z*2+(h/fact));

  
   //println(py-v);
   //int zard = int(random(2));
   if (beat.isKick()){
    rotateY(radians(inc*angC/40));
   }else {
     rotateY(-radians(inc*angZ/40));
   }
   //println("c'estlecas1=====" +( py-v));
   //filter(BLUR, 1);
     if(py-v > 5){
  // println("cestlecas1");
    int haz = PApplet.parseInt(random(2));
    if(haz==1){
   ellipse(px, py-v, w, h+(x*2));
    }else{
      ellipse(px-x/4, py-v, w-(x), h+(x*2));
    }
     
     //point(px, py-v);
    }else{
      v= 0.0000000000000000001f;
     //println("cestlecas2");
     int haz = PApplet.parseInt(random(20));
    if(haz== 1 && !tempsFort){
     ellipse(px+x+v*2, py+v, w-z, (h+z)*tempo*4);
    }else{
     
      ellipse(px-x-v, py-v, w-x, h+(x*2));
      //ellipse(px-x/2, py-v, w+(x), h+(x/2));
    }
     
    }
   
    popMatrix();
    inc++;
     v++;
   
  }
  
  
  
  
  
  
  
  
}
class BeatListener implements AudioListener
{
  private BeatDetect beat;
  private AudioInput source;
  
  BeatListener(BeatDetect beat, AudioInput source)
  {
    this.source = source;
    this.source.addListener(this);
    this.beat = beat;
  }
  
  public void samples(float[] samps)
  {
    beat.detect(source.mix);
  }
  
  public void samples(float[] sampsL, float[] sampsR)
  {
    beat.detect(source.mix);
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "valse" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
